--- old/usr/src/uts/common/sys/zone.h	Wed Oct  5 00:33:56 2016
+++ new/usr/src/uts/common/sys/zone.h	Wed Oct  5 00:33:56 2016
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2015 Joyent, Inc. All rights reserved.
  * Copyright 2014 Nexenta Systems, Inc. All rights reserved.
  * Copyright 2014 Igor Kozhukhov <ikozhukhov@gmail.com>.
  * Copyright 2016, Joyent, Inc.
@@ -190,7 +191,6 @@
 	uint32_t doi;			/* DOI for label */
 	caddr32_t label;		/* label associated with zone */
 	int flags;
-	zoneid_t zoneid;		/* requested zoneid */
 } zone_def32;
 #endif
 typedef struct {
@@ -207,7 +207,6 @@
 	uint32_t doi;			/* DOI for label */
 	const bslabel_t *label;		/* label associated with zone */
 	int flags;
-	zoneid_t zoneid;		/* requested zoneid */
 } zone_def;
 
 /* extended error information */
@@ -383,7 +382,7 @@
 } zone_dataset_t;
 
 /*
- * structure for rctl zone kstats
+ * structure for zone kstats
  */
 typedef struct zone_kstat {
 	kstat_named_t zk_zonename;
@@ -459,7 +458,6 @@
 	kstat_named_t	zm_ffnoproc;
 	kstat_named_t	zm_ffnomem;
 	kstat_named_t	zm_ffmisc;
-	kstat_named_t	zm_mfseglim;
 	kstat_named_t	zm_nested_intp;
 	kstat_named_t	zm_init_pid;
 	kstat_named_t	zm_boot_time;
@@ -504,7 +502,6 @@
 	 */
 	list_node_t	zone_linkage;
 	zoneid_t	zone_id;	/* ID of zone */
-	zoneid_t	zone_did;	/* persistent debug ID of zone */
 	uint_t		zone_ref;	/* count of zone_hold()s on zone */
 	uint_t		zone_cred_ref;	/* count of zone_hold_cred()s on zone */
 	/*
@@ -629,6 +626,13 @@
 	sys_zio_cntr_t	zone_lwr_ops;		/* logical writes. */
 
 	/*
+	 * kstats and counters for I/O ops and bytes.
+	 */
+	kmutex_t	zone_io_lock;		/* protects I/O statistics */
+	kstat_t		*zone_io_ksp;
+	kstat_io_t	*zone_io_kiop;
+
+	/*
 	 * kstats and counters for VFS ops and bytes.
 	 */
 	kmutex_t	zone_vfs_lock;		/* protects VFS statistics */
@@ -640,7 +644,6 @@
 	 * kstats for ZFS I/O ops and bytes.
 	 */
 	kmutex_t	zone_zfs_lock;		/* protects ZFS statistics */
-	kstat_t		*zone_zfs_ksp;
 	kstat_io_t	zone_zfs_rwstats;
 	zone_zfs_kstat_t *zone_zfs_stats;
 
@@ -707,8 +710,6 @@
 	uint32_t	zone_ffnomem;		/* as_dup/memory error */
 	uint32_t	zone_ffmisc;		/* misc. other error */
 
-	uint32_t	zone_mfseglim;		/* map failure (# segs limit) */
-
 	uint32_t	zone_nested_intp;	/* nested interp. kstat */
 
 	struct loadavg_s zone_loadavg;		/* loadavg for this zone */
@@ -765,7 +766,6 @@
 extern zone_t *zone_find_by_any_path(const char *, boolean_t);
 extern zone_t *zone_find_by_path(const char *);
 extern zoneid_t getzoneid(void);
-extern zoneid_t getzonedid(void);
 extern zone_t *zone_find_by_id_nolock(zoneid_t);
 extern int zone_datalink_walk(zoneid_t, int (*)(datalink_id_t, void *), void *);
 extern int zone_check_datalink(zoneid_t *, datalink_id_t);
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/syscall/sysconfig.c	Wed Oct  5 00:33:57 2016
+++ new/usr/src/uts/common/syscall/sysconfig.c	Wed Oct  5 00:33:57 2016
@@ -22,7 +22,7 @@
 /*
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
- * Copyright 2012 Joyent, Inc.  All rights reserved.
+ * Copyright 2011 Joyent, Inc.  All rights reserved.
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
@@ -180,23 +180,26 @@
 	case _CONFIG_AVPHYS_PAGES:
 		/*
 		 * If the non-global zone has a phys. memory cap, use
-		 * the phys. memory cap - zone's rss.  We always
+		 * the phys. memory cap - zone's current rss.  We always
 		 * report the system-wide value for the global zone, even
-		 * though memory capping can be used on the global zone too.
-		 * We use the cached value for the RSS since vm_getusage()
-		 * is so expensive and we don't need this value to be exact.
+		 * though rcapd can be used on the global zone too.
 		 */
 		if (!INGLOBALZONE(curproc) &&
 		    curproc->p_zone->zone_phys_mem_ctl != UINT64_MAX) {
 			pgcnt_t cap, rss, free;
+			vmusage_t in_use;
+			size_t cnt = 1;
 
 			cap = btop(curproc->p_zone->zone_phys_mem_ctl);
 			if (cap > physinstalled)
 				return (freemem);
 
-			rss = btop(curproc->p_zone->zone_phys_mem);
+			if (vm_getusage(VMUSAGE_ZONE, 1, &in_use, &cnt,
+			    FKIOCTL) != 0)
+				in_use.vmu_rss_all = 0;
+			rss = btop(in_use.vmu_rss_all);
 			/*
-			 * Because this is a soft cap, it is possible
+			 * Because rcapd implements a soft cap, it is possible
 			 * for rss to be temporarily over the cap.
 			 */
 			if (cap > rss)
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/vm/vm_as.c	Wed Oct  5 00:33:58 2016
+++ new/usr/src/uts/common/vm/vm_as.c	Wed Oct  5 00:33:58 2016
@@ -21,7 +21,7 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
- * Copyright 2016 Joyent, Inc.
+ * Copyright 2015, Joyent, Inc.  All rights reserved.
  * Copyright (c) 2016 by Delphix. All rights reserved.
  */
 
@@ -72,8 +72,6 @@
 
 clock_t deadlk_wait = 1; /* number of ticks to wait before retrying */
 
-ulong_t as_user_seg_limit = 0xffff; /* max segments in an (non-kas) AS */
-
 static struct kmem_cache *as_cache;
 
 static void as_setwatchprot(struct as *, caddr_t, size_t, uint_t);
@@ -891,19 +889,19 @@
 		CPU_STATS_EXIT_K();
 		if (zonep->zone_pg_flt_delay != 0) {
 			/*
-			 * The zone in which this process is running is
-			 * currently over it's physical memory cap. Throttle
-			 * page faults to help the user-land memory capper
-			 * catch up. Note that drv_usectohz() rounds up.
+			 * The zone in which this process is running
+			 * is currently over it's physical memory cap.
+			 * Throttle page faults to help the user-land
+			 * memory capper catch up. Note that
+			 * drv_usectohz() rounds up.
 			 */
 			atomic_add_64(&zonep->zone_pf_throttle, 1);
 			atomic_add_64(&zonep->zone_pf_throttle_usec,
 			    zonep->zone_pg_flt_delay);
-			if (zonep->zone_pg_flt_delay < TICK_TO_USEC(1)) {
+			if (zonep->zone_pg_flt_delay < TICK_TO_USEC(1))
 				drv_usecwait(zonep->zone_pg_flt_delay);
-			} else {
+			else
 				delay(drv_usectohz(zonep->zone_pg_flt_delay));
-			}
 		}
 		break;
 	}
@@ -1711,28 +1709,13 @@
 	as->a_updatedir = 1;	/* inform /proc */
 	gethrestime(&as->a_updatetime);
 
-	if (as != &kas) {
-		if (as->a_size + rsize > (size_t)p->p_vmem_ctl) {
-			AS_LOCK_EXIT(as);
+	if (as != &kas && as->a_size + rsize > (size_t)p->p_vmem_ctl) {
+		AS_LOCK_EXIT(as);
 
-			(void) rctl_action(rctlproc_legacy[RLIMIT_VMEM],
-			    p->p_rctls, p, RCA_UNSAFE_ALL);
-			return (ENOMEM);
-		}
+		(void) rctl_action(rctlproc_legacy[RLIMIT_VMEM], p->p_rctls, p,
+		    RCA_UNSAFE_ALL);
 
-		/*
-		 * Keep the number of segments in a userspace AS constrained to
-		 * a reasonable limit.  Linux enforces a value slightly less
-		 * than 64k in order to avoid ELF limits if/when a process
-		 * dumps core.  While SunOS avoids that specific problem with
-		 * other tricks, the limit is still valuable to keep kernel
-		 * memory consumption in check.
-		 */
-		if (avl_numnodes(&as->a_segtree) >= as_user_seg_limit) {
-			AS_LOCK_EXIT(as);
-			atomic_inc_32(&p->p_zone->zone_mfseglim);
-			return (ENOMEM);
-		}
+		return (ENOMEM);
 	}
 
 	if (AS_MAP_CHECK_VNODE_LPOOB(crfp, argsp)) {
--- old/usr/src/uts/common/vm/vm_usage.c	Wed Oct  5 00:33:58 2016
+++ new/usr/src/uts/common/vm/vm_usage.c	Wed Oct  5 00:33:58 2016
@@ -118,7 +118,7 @@
  *	For accurate counting of map-shared and COW-shared pages.
  *
  *    - visited private anons (refcnt > 1) for each collective.
- *	(entity->vme_anon)
+ *	(entity->vme_anon_hash)
  *	For accurate counting of COW-shared pages.
  *
  * The common accounting structure is the vmu_entity_t, which represents
@@ -156,7 +156,6 @@
 #include <sys/vm_usage.h>
 #include <sys/zone.h>
 #include <sys/sunddi.h>
-#include <sys/sysmacros.h>
 #include <sys/avl.h>
 #include <vm/anon.h>
 #include <vm/as.h>
@@ -204,14 +203,6 @@
 } vmu_object_t;
 
 /*
- * Node for tree of visited COW anons.
- */
-typedef struct vmu_anon {
-	avl_node_t vma_node;
-	uintptr_t vma_addr;
-} vmu_anon_t;
-
-/*
  * Entity by which to count results.
  *
  * The entity structure keeps the current rss/swap counts for each entity
@@ -234,7 +225,7 @@
 	struct vmu_entity *vme_next_calc;
 	mod_hash_t	*vme_vnode_hash; /* vnodes visited for entity */
 	mod_hash_t	*vme_amp_hash;	 /* shared amps visited for entity */
-	avl_tree_t	vme_anon;	 /* COW anons visited for entity */
+	mod_hash_t	*vme_anon_hash;	 /* COW anons visited for entity */
 	vmusage_t	vme_result;	 /* identifies entity and results */
 } vmu_entity_t;
 
@@ -337,23 +328,6 @@
 }
 
 /*
- * Comparison routine for our AVL tree of anon structures.
- */
-static int
-vmu_anon_cmp(const void *lhs, const void *rhs)
-{
-	const vmu_anon_t *l = lhs, *r = rhs;
-
-	if (l->vma_addr == r->vma_addr)
-		return (0);
-
-	if (l->vma_addr < r->vma_addr)
-		return (-1);
-
-	return (1);
-}
-
-/*
  * Save a bound on the free list.
  */
 static void
@@ -393,19 +367,14 @@
 vmu_free_entity(mod_hash_val_t val)
 {
 	vmu_entity_t *entity = (vmu_entity_t *)val;
-	vmu_anon_t *anon;
-	void *cookie = NULL;
 
 	if (entity->vme_vnode_hash != NULL)
 		i_mod_hash_clear_nosync(entity->vme_vnode_hash);
 	if (entity->vme_amp_hash != NULL)
 		i_mod_hash_clear_nosync(entity->vme_amp_hash);
+	if (entity->vme_anon_hash != NULL)
+		i_mod_hash_clear_nosync(entity->vme_anon_hash);
 
-	while ((anon = avl_destroy_nodes(&entity->vme_anon, &cookie)) != NULL)
-		kmem_free(anon, sizeof (vmu_anon_t));
-
-	avl_destroy(&entity->vme_anon);
-
 	entity->vme_next = vmu_data.vmu_free_entities;
 	vmu_data.vmu_free_entities = entity;
 }
@@ -520,11 +489,11 @@
 		    "vmusage amp hash", VMUSAGE_HASH_SIZE, vmu_free_object,
 		    sizeof (struct anon_map));
 
-	VERIFY(avl_first(&entity->vme_anon) == NULL);
+	if (entity->vme_anon_hash == NULL)
+		entity->vme_anon_hash = mod_hash_create_ptrhash(
+		    "vmusage anon hash", VMUSAGE_HASH_SIZE,
+		    mod_hash_null_valdtor, sizeof (struct anon));
 
-	avl_create(&entity->vme_anon, vmu_anon_cmp, sizeof (struct vmu_anon),
-	    offsetof(struct vmu_anon, vma_node));
-
 	entity->vme_next = vmu_data.vmu_entities;
 	vmu_data.vmu_entities = entity;
 	vmu_data.vmu_nentities++;
@@ -649,19 +618,21 @@
 }
 
 static int
-vmu_find_insert_anon(vmu_entity_t *entity, void *key)
+vmu_find_insert_anon(mod_hash_t *hash, caddr_t key)
 {
-	vmu_anon_t anon, *ap;
+	int ret;
+	caddr_t val;
 
-	anon.vma_addr = (uintptr_t)key;
+	ret = i_mod_hash_find_nosync(hash, (mod_hash_key_t)key,
+	    (mod_hash_val_t *)&val);
 
-	if (avl_find(&entity->vme_anon, &anon, NULL) != NULL)
+	if (ret == 0)
 		return (0);
 
-	ap = kmem_alloc(sizeof (vmu_anon_t), KM_SLEEP);
-	ap->vma_addr = (uintptr_t)key;
+	ret = i_mod_hash_insert_nosync(hash, (mod_hash_key_t)key,
+	    (mod_hash_val_t)key, (mod_hash_hndl_t)0);
 
-	avl_add(&entity->vme_anon, ap);
+	ASSERT(ret == 0);
 
 	return (1);
 }
@@ -1373,7 +1344,8 @@
 				 * Track COW anons per entity so
 				 * they are not double counted.
 				 */
-				if (vmu_find_insert_anon(entity, ap) == 0)
+				if (vmu_find_insert_anon(entity->vme_anon_hash,
+				    (caddr_t)ap) == 0)
 					continue;
 
 				result->vmu_rss_all += (pgcnt << PAGESHIFT);
@@ -1647,7 +1619,8 @@
 			mod_hash_destroy_hash(te->vme_vnode_hash);
 		if (te->vme_amp_hash != NULL)
 			mod_hash_destroy_hash(te->vme_amp_hash);
-		VERIFY(avl_first(&te->vme_anon) == NULL);
+		if (te->vme_anon_hash != NULL)
+			mod_hash_destroy_hash(te->vme_anon_hash);
 		kmem_free(te, sizeof (vmu_entity_t));
 	}
 	while (vmu_data.vmu_free_zones != NULL) {
@@ -1805,8 +1778,8 @@
 		if (rp->vmu_type == VMUSAGE_ZONE &&
 		    rp->vmu_zoneid != ALL_ZONES) {
 			if ((zp = zone_find_by_id(rp->vmu_zoneid)) != NULL) {
-				zp->zone_phys_mem = rp->vmu_rss_all;
-				zone_rele(zp);
+			        zp->zone_phys_mem = rp->vmu_rss_all;
+			        zone_rele(zp);
 			}
 		}
 	}
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/i86pc/ml/syscall_asm_amd64.s	Wed Oct  5 00:33:58 2016
+++ new/usr/src/uts/i86pc/ml/syscall_asm_amd64.s	Wed Oct  5 00:33:58 2016
@@ -28,7 +28,6 @@
 #include <sys/regset.h>
 #include <sys/privregs.h>
 #include <sys/psw.h>
-#include <sys/machbrand.h>
 
 #if defined(__lint)
 
@@ -38,6 +37,7 @@
 
 #else	/* __lint */
 
+#include <sys/machbrand.h>
 #include <sys/segments.h>
 #include <sys/pcb.h>
 #include <sys/trap.h>
@@ -531,22 +531,13 @@
 	addq	$8, %rsp
 
 	/*
-	 * If the alternate handler returns non-zero, the normal system call
-	 * processing is resumed.
+	 * If the alternate handler returns 0, we skip straight to the return to
+	 * usermode.  Otherwise, we resume regular system call processing.
 	 */
 	testl	%eax, %eax
 	popq	%rax
-	jnz	_syscall_no_brand
+	jz	_syscall_after_brand
 
-	/*
-	 * For branded syscalls which were handled in-kernel, shuffle the
-	 * register state as would be done by the native handler before jumping
-	 * to the post-syscall logic.
-	 */
-	movq	REGOFF_RAX(%rsp), %r12
-	movq	REGOFF_RDX(%rsp), %r13
-	jmp	_syscall_after_brand
-
 _syscall_no_brand:
 	movw	%ax, T_SYSNUM(%r15)
 	movzbl	T_PRE_SYS(%r15), %ebx
@@ -840,21 +831,12 @@
 	call	*%rax
 
 	/*
-	 * If the alternate handler returns non-zero, the normal system call
-	 * processing is resumed.
+	 * If the alternate handler returns 0, we skip straight to the return
+	 * to usermode.  Otherwise, we resume regular system call processing.
 	 */
 	testl	%eax, %eax
-	jnz	_syscall32_no_brand
+	jz	_syscall32_after_brand
 
-	/*
-	 * For branded syscalls which were handled in-kernel, shuffle the
-	 * register state as would be done by the native handler before jumping
-	 * to the post-syscall logic.
-	 */
-	movl	REGOFF_RAX(%rsp), %r12d
-	movl	REGOFF_RDX(%rsp), %r13d
-	jmp	_syscall32_after_brand
-
 _syscall32_no_brand:
 	/*
 	 * Make some space for MAXSYSARGS (currently 8) 32-bit args placed
@@ -1255,7 +1237,6 @@
 	ENTRY_NP(brand_sys_int80)
 	SWAPGS				/* kernel gsbase */
 	XPV_TRAP_POP
-	call	smap_enable
 
 	/*
 	 * We first attempt to call the "b_int80" handler from the "struct
@@ -1294,7 +1275,6 @@
 	 * because gptrap will pop them again with its own XPV_TRAP_POP.
 	 */
 	XPV_TRAP_POP
-	call	smap_enable
 nopop_int80:
 	subq	$2, (%rsp)	/* int insn 2-bytes */
 	pushq	$_CONST(_MUL(T_INT80, GATE_DESC_SIZE) + 2)
No differences encountered
No differences encountered
--- old/usr/src/uts/i86pc/os/mp_startup.c	Wed Oct  5 00:33:59 2016
+++ new/usr/src/uts/i86pc/os/mp_startup.c	Wed Oct  5 00:33:59 2016
@@ -166,8 +166,6 @@
 void
 init_cpu_syscall(struct cpu *cp)
 {
-	uint64_t flags;
-
 	kpreempt_disable();
 
 #if defined(__amd64)
--- old/usr/src/uts/i86pc/os/timestamp.c	Wed Oct  5 00:33:59 2016
+++ new/usr/src/uts/i86pc/os/timestamp.c	Wed Oct  5 00:33:59 2016
@@ -145,6 +145,8 @@
 	volatile hrtime_t master_tsc, slave_tsc;
 } tsc_sync_t;
 static tsc_sync_t *tscp;
+static hrtime_t largest_tsc_delta = 0;
+static ulong_t shortest_write_time = ~0UL;
 
 static hrtime_t	tsc_last_jumped = 0;
 static int	tsc_jumped = 0;
@@ -445,28 +447,26 @@
 }
 
 /*
- * TSC Sync Master
+ * Called by the master in the TSC sync operation (usually the boot CPU).
+ * If the slave is discovered to have a skew, gethrtimef will be changed to
+ * point to tsc_gethrtime_delta(). Calculating skews is precise only when
+ * the master and slave TSCs are read simultaneously; however, there is no
+ * algorithm that can read both CPUs in perfect simultaneity. The proposed
+ * algorithm is an approximate method based on the behaviour of cache
+ * management. The slave CPU continuously reads TSC and then reads a global
+ * variable which the master CPU updates. The moment the master's update reaches
+ * the slave's visibility (being forced by an mfence operation) we use the TSC
+ * reading taken on the slave. A corresponding TSC read will be taken on the
+ * master as soon as possible after finishing the mfence operation. But the
+ * delay between causing the slave to notice the invalid cache line and the
+ * competion of mfence is not repeatable. This error is heuristically assumed
+ * to be 1/4th of the total write time as being measured by the two TSC reads
+ * on the master sandwiching the mfence. Furthermore, due to the nature of
+ * bus arbitration, contention on memory bus, etc., the time taken for the write
+ * to reflect globally can vary a lot. So instead of taking a single reading,
+ * a set of readings are taken and the one with least write time is chosen
+ * to calculate the final skew.
  *
- * Typically called on the boot CPU, this attempts to quantify TSC skew between
- * different CPUs.  If an appreciable difference is found, gethrtimef will be
- * changed to point to tsc_gethrtime_delta().
- *
- * Calculating skews is precise only when the master and slave TSCs are read
- * simultaneously; however, there is no algorithm that can read both CPUs in
- * perfect simultaneity.  The proposed algorithm is an approximate method based
- * on the behaviour of cache management.  The slave CPU continuously polls the
- * TSC while reading a global variable updated by the master CPU.  The latest
- * TSC reading is saved when the master's update (forced via mfence) reaches
- * visibility on the slave.  The master will also take a TSC reading
- * immediately following the mfence.
- *
- * While the delay between cache line invalidation on the slave and mfence
- * completion on the master is not repeatable, the error is heuristically
- * assumed to be 1/4th of the write time recorded by the master.  Multiple
- * samples are taken to control for the variance caused by external factors
- * such as bus contention.  Each sample set is independent per-CPU to control
- * for differing memory latency on NUMA systems.
- *
  * TSC sync is disabled in the context of virtualization because the CPUs
  * assigned to the guest are virtual CPUs which means the real CPUs on which
  * guest runs keep changing during life time of guest OS. So we would end up
@@ -478,7 +478,7 @@
 tsc_sync_master(processorid_t slave)
 {
 	ulong_t flags, source, min_write_time = ~0UL;
-	hrtime_t write_time, mtsc_after, last_delta = 0;
+	hrtime_t write_time, x, mtsc_after, tdelta;
 	tsc_sync_t *tsc = tscp;
 	int cnt;
 	int hwtype;
@@ -501,26 +501,28 @@
 			SMT_PAUSE();
 		write_time =  mtsc_after - tsc->master_tsc;
 		if (write_time <= min_write_time) {
-			hrtime_t tdelta;
-
-			tdelta = tsc->slave_tsc - mtsc_after;
-			if (tdelta < 0)
-				tdelta = -tdelta;
+			min_write_time = write_time;
 			/*
-			 * If the margin exists, subtract 1/4th of the measured
-			 * write time from the master's TSC value.  This is an
-			 * estimate of how late the mfence completion came
-			 * after the slave noticed the cache line change.
+			 * Apply heuristic adjustment only if the calculated
+			 * delta is > 1/4th of the write time.
 			 */
-			if (tdelta > (write_time/4)) {
+			x = tsc->slave_tsc - mtsc_after;
+			if (x < 0)
+				x = -x;
+			if (x > (min_write_time/4))
+				/*
+				 * Subtract 1/4th of the measured write time
+				 * from the master's TSC value, as an estimate
+				 * of how late the mfence completion came
+				 * after the slave noticed the cache line
+				 * change.
+				 */
 				tdelta = tsc->slave_tsc -
-				    (mtsc_after - (write_time/4));
-			} else {
+				    (mtsc_after - (min_write_time/4));
+			else
 				tdelta = tsc->slave_tsc - mtsc_after;
-			}
-			last_delta = tsc_sync_tick_delta[source] - tdelta;
-			tsc_sync_tick_delta[slave] = last_delta;
-			min_write_time = write_time;
+			tsc_sync_tick_delta[slave] =
+			    tsc_sync_tick_delta[source] - tdelta;
 		}
 
 		tsc->master_tsc = tsc->slave_tsc = write_time = 0;
@@ -527,13 +529,17 @@
 		membar_enter();
 		tsc_sync_go = TSC_SYNC_STOP;
 	}
-
+	if (tdelta < 0)
+		tdelta = -tdelta;
+	if (tdelta > largest_tsc_delta)
+		largest_tsc_delta = tdelta;
+	if (min_write_time < shortest_write_time)
+		shortest_write_time = min_write_time;
 	/*
-	 * Only enable the delta variants of the TSC functions if the measured
-	 * skew is greater than the fastest write time.
+	 * Enable delta variants of tsc functions if the largest of all chosen
+	 * deltas is > smallest of the write time.
 	 */
-	last_delta = (last_delta < 0) ? -last_delta : last_delta;
-	if (last_delta > min_write_time) {
+	if (largest_tsc_delta > shortest_write_time) {
 		gethrtimef = tsc_gethrtime_delta;
 		gethrtimeunscaledf = tsc_gethrtimeunscaled_delta;
 		tsc_ncpu = NCPU;
@@ -542,12 +548,11 @@
 }
 
 /*
- * TSC Sync Slave
- *
  * Called by a CPU which has just been onlined.  It is expected that the CPU
  * performing the online operation will call tsc_sync_master().
  *
- * Like tsc_sync_master, this logic is skipped on virtualized platforms.
+ * TSC sync is disabled in the context of virtualization. See comments
+ * above tsc_sync_master.
  */
 void
 tsc_sync_slave(void)
@@ -571,9 +576,11 @@
 		tsc_sync_go = TSC_SYNC_GO;
 		do {
 			/*
-			 * Do not put an SMT_PAUSE here.  If the master and
-			 * slave are the same hyper-threaded CPU, we want the
-			 * master to yield as quickly as possible to the slave.
+			 * Do not put an SMT_PAUSE here. For instance,
+			 * if the master and slave are really the same
+			 * hyper-threaded CPU, then you want the master
+			 * to yield to the slave as quickly as possible here,
+			 * but not the other way.
 			 */
 			s1 = tsc_read();
 		} while (tsc->master_tsc == 0);
@@ -704,10 +711,12 @@
 }
 
 /*
- * Adjust all the deltas by adding the passed value to the array and activate
- * the "delta" versions of the gethrtime functions.  It is possible that the
- * adjustment could be negative.  Such may occur if the SunOS instance was
- * moved by a virtual manager to a machine with a higher value of TSC.
+ * Adjust all the deltas by adding the passed value to the array.
+ * Then use the "delt" versions of the the gethrtime functions.
+ * Note that 'tdelta' _could_ be a negative number, which should
+ * reduce the values in the array (used, for example, if the Solaris
+ * instance was moved by a virtual manager to a machine with a higher
+ * value of tsc).
  */
 void
 tsc_adjust_delta(hrtime_t tdelta)
@@ -727,9 +736,13 @@
  * Functions to manage TSC and high-res time on suspend and resume.
  */
 
-/* tod_ops from "uts/i86pc/io/todpc_subr.c" */
+/*
+ * declarations needed for time adjustment
+ */
+extern void	rtcsync(void);
 extern tod_ops_t *tod_ops;
-
+/* There must be a better way than exposing nsec_scale! */
+extern uint_t	nsec_scale;
 static uint64_t tsc_saved_tsc = 0; /* 1 in 2^64 chance this'll screw up! */
 static timestruc_t tsc_saved_ts;
 static int	tsc_needs_resume = 0;	/* We only want to do this once. */
@@ -739,20 +752,23 @@
 int		tsc_resume_in_cyclic = 0;
 
 /*
- * Take snapshots of the current time and do any other pre-suspend work.
+ * Let timestamp.c know that we are suspending.  It needs to take
+ * snapshots of the current time, and do any pre-suspend work.
  */
 void
 tsc_suspend(void)
 {
-	/*
-	 * We need to collect the time at which we suspended here so we know
-	 * now much should be added during the resume.  This is called by each
-	 * CPU, so reentry must be properly handled.
-	 */
+/*
+ * What we need to do here, is to get the time we suspended, so that we
+ * know how much we should add to the resume.
+ * This routine is called by each CPU, so we need to handle reentry.
+ */
 	if (tsc_gethrtime_enable) {
 		/*
-		 * Perform the tsc_read after acquiring the lock to make it as
-		 * accurate as possible in the face of contention.
+		 * We put the tsc_read() inside the lock as it
+		 * as no locking constraints, and it puts the
+		 * aquired value closer to the time stamp (in
+		 * case we delay getting the lock).
 		 */
 		mutex_enter(&tod_lock);
 		tsc_saved_tsc = tsc_read();
@@ -774,7 +790,8 @@
 }
 
 /*
- * Restore all timestamp state based on the snapshots taken at suspend time.
+ * Restore all timestamp state based on the snapshots taken at
+ * suspend time.
  */
 void
 tsc_resume(void)
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/i86pc/unix/Makefile	Wed Oct  5 00:33:59 2016
+++ new/usr/src/uts/i86pc/unix/Makefile	Wed Oct  5 00:33:59 2016
@@ -22,7 +22,6 @@
 #
 # Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
-# Copyright 2016 Joyent, Inc.
 #
 #	This makefile drives the production of unix (and unix.o).
 #
--- old/usr/src/uts/intel/Makefile.files	Wed Oct  5 00:34:00 2016
+++ new/usr/src/uts/intel/Makefile.files	Wed Oct  5 00:34:00 2016
@@ -207,54 +207,38 @@
 #
 #	misc. modules
 #
-ACPICA_OBJS	+= \
-		   dmbuffer.o dmcstyle.o dmdeferred.o dmnames.o dmopcode.o \
-		   dmresrc.o dmresrcl.o dmresrcl2.o dmresrcs.o dmutils.o \
-		   dmwalk.o \
-		   \
-		   dsargs.o dscontrol.o dsdebug.o dsfield.o dsinit.o \
-		   dsmethod.o dsmthdat.o dsobject.o dsopcode.o dsutils.o \
-		   dswexec.o dswload.o dswload2.o dswscope.o dswstate.o \
-		   \
-		   evevent.o evglock.o evgpe.o evgpeblk.o evgpeinit.o \
-		   evgpeutil.o evhandler.o evmisc.o evregion.o evrgnini.o \
-		   evsci.o evxface.o evxfevnt.o evxfgpe.o evxfregn.o \
-		   \
-		   exconcat.o exconfig.o exconvrt.o excreate.o exdebug.o \
-		   exdump.o exfield.o exfldio.o exmisc.o exmutex.o exnames.o \
-		   exoparg1.o exoparg2.o exoparg3.o exoparg6.o exprep.o \
-		   exregion.o exresnte.o exresolv.o exresop.o exstore.o \
-		   exstoren.o exstorob.o exsystem.o extrace.o exutils.o \
-		   \
-		   hwacpi.o hwesleep.o hwgpe.o hwpci.o hwregs.o hwsleep.o \
-		   hwtimer.o hwvalid.o hwxface.o hwxfsleep.o \
-		   \
-		   psargs.o psloop.o psobject.o psopcode.o psopinfo.o \
-		   psparse.o psscope.o pstree.o psutils.o pswalk.o psxface.o \
-		   \
-		   nsaccess.o nsalloc.o nsarguments.o nsconvert.o nsdump.o \
-		   nsdumpdv.o nseval.o nsinit.o nsload.o nsnames.o nsobject.o \
-		   nsparse.o nspredef.o nsprepkg.o nsrepair.o nsrepair2.o \
-		   nssearch.o nsutils.o nswalk.o nsxfeval.o nsxfname.o \
-		   nsxfobj.o \
-		   \
-		   rsaddr.o rscalc.o rscreate.o rsdump.o rsdumpinfo.o \
+ACPICA_OBJS	+= dbcmds.o dbdisply.o \
+		   dbexec.o dbfileio.o dbhistry.o dbinput.o dbstats.o \
+		   dbutils.o dbxface.o evevent.o evgpe.o evgpeblk.o \
+		   evmisc.o evregion.o evrgnini.o evsci.o evxface.o \
+		   evxfevnt.o evxfregn.o hwacpi.o hwgpe.o hwregs.o \
+		   hwsleep.o hwtimer.o dsfield.o dsinit.o dsmethod.o \
+		   dsmthdat.o dsobject.o dsopcode.o dsutils.o dswexec.o \
+		   dswload.o dswscope.o dswstate.o exconfig.o exconvrt.o \
+		   excreate.o exdump.o exfield.o exfldio.o exmisc.o \
+		   exmutex.o exnames.o exoparg1.o exoparg2.o exoparg3.o \
+		   exoparg6.o exprep.o exregion.o exresnte.o exresolv.o \
+		   exresop.o exstore.o exstoren.o exstorob.o exsystem.o \
+		   exutils.o psargs.o psopcode.o psparse.o psscope.o \
+		   pstree.o psutils.o pswalk.o psxface.o nsaccess.o \
+		   nsalloc.o nsdump.o nsdumpdv.o nseval.o nsinit.o \
+		   nsload.o nsnames.o nsobject.o nsparse.o nssearch.o \
+		   nsutils.o nswalk.o nsxfeval.o nsxfname.o nsxfobj.o \
+		   rsaddr.o rscalc.o rscreate.o rsdump.o \
 		   rsinfo.o rsio.o rsirq.o rslist.o rsmemory.o rsmisc.o \
-		   rsserial.o rsutils.o rsxface.o \
-		   \
-		   tbdata.o tbfadt.o tbfind.o tbinstal.o tbprint.o tbutils.o \
-		   tbxface.o tbxfload.o tbxfroot.o \
-		   \
-		   utaddress.o utalloc.o utascii.o utbuffer.o utcache.o \
-		   utclib.o utcopy.o utdebug.o utdecode.o utdelete.o \
-		   uterror.o uteval.o utexcep.o utglobal.o uthex.o utids.o \
-		   utinit.o utlock.o utmath.o utmisc.o utmutex.o utnonansi.o \
-		   utobject.o utosi.o utownerid.o utpredef.o utprint.o \
-		   utresrc.o utstate.o utstring.o uttrack.o utuuid.o utxface.o \
-		   utxferror.o utxfinit.o utxfmutex.o \
-		   \
-		   acpi_enum.o acpica_ec.o acpica.o ahids.o master_ops.o \
-		   osl_ml.o osl.o
+		   rsutils.o rsxface.o tbfadt.o tbfind.o tbinstal.o  \
+		   tbutils.o tbxface.o tbxfroot.o \
+		   utalloc.o utclib.o utcopy.o utdebug.o utdelete.o \
+		   uteval.o utglobal.o utinit.o utmath.o utmisc.o \
+		   utobject.o utresrc.o utxface.o acpica.o acpi_enum.o \
+		   master_ops.o osl.o osl_ml.o acpica_ec.o utcache.o \
+		   utmutex.o utstate.o dmbuffer.o dmnames.o dmobject.o \
+		   dmopcode.o dmresrc.o dmresrcl.o dmresrcs.o dmutils.o \
+		   dmwalk.o psloop.o nspredef.o hwxface.o hwvalid.o \
+		   utlock.o utids.o nsrepair.o nsrepair2.o \
+		   dbmethod.o dbnames.o dsargs.o dscontrol.o dswload2.o \
+		   evglock.o evgpeinit.o evgpeutil.o evxfgpe.o exdebug.o \
+		   hwpci.o utdecode.o utosi.o utxferror.o
 
 
 AGP_OBJS += agpmaster.o
--- old/usr/src/uts/intel/Makefile.intel	Wed Oct  5 00:34:00 2016
+++ new/usr/src/uts/intel/Makefile.intel	Wed Oct  5 00:34:00 2016
@@ -242,7 +242,6 @@
 DRV_KMODS	+= dld
 DRV_KMODS	+= dlpistub
 DRV_KMODS_32	+= dnet
-DRV_KMODS	+= dr_sas
 DRV_KMODS	+= dump
 DRV_KMODS	+= ecpp
 DRV_KMODS	+= emlxs
@@ -291,7 +290,6 @@
 DRV_KMODS	+= mr_sas
 DRV_KMODS	+= mwl 
 DRV_KMODS	+= nca
-DRV_KMODS	+= nfp
 DRV_KMODS	+= nsmb
 DRV_KMODS	+= nulldriver
 DRV_KMODS	+= nv_sata
@@ -361,8 +359,6 @@
 DRV_KMODS	+= urtw
 DRV_KMODS	+= vgatext
 DRV_KMODS	+= heci
-DRV_KMODS	+= vmxnet 
-DRV_KMODS	+= vnd
 DRV_KMODS	+= vnic
 DRV_KMODS	+= vscan
 DRV_KMODS	+= wc
@@ -374,7 +370,6 @@
 DRV_KMODS	+= zfd
 DRV_KMODS	+= zyd
 DRV_KMODS	+= simnet
-DRV_KMODS	+= smrt
 DRV_KMODS	+= stmf
 DRV_KMODS	+= stmf_sbd
 DRV_KMODS	+= fct
@@ -502,15 +497,6 @@
 DRV_KMODS	+= usbecm
 
 #
-#	USBGEM modules
-#
-DRV_KMODS	+= usbgem
-DRV_KMODS	+= axf
-DRV_KMODS	+= udmf 
-DRV_KMODS	+= upf
-DRV_KMODS	+= urf 
-
-#
 #	1394 modules
 #
 MISC_KMODS	+= s1394 sbp2
@@ -550,8 +536,8 @@
 #
 #	File System Modules (/kernel/fs):
 #
-FS_KMODS	+= autofs ctfs dcfs dev devfs fdfs fifofs hsfs hyprlofs
-FS_KMODS	+= lofs lxautofs lx_proc lxprocfs mntfs namefs nfs objfs zfs zut
+FS_KMODS	+= autofs ctfs dcfs dev devfs fdfs fifofs hsfs lofs
+FS_KMODS	+= lxautofs lx_proc mntfs namefs nfs objfs zfs zut
 FS_KMODS	+= pcfs procfs sockfs specfs tmpfs udfs ufs sharefs lx_sysfs
 FS_KMODS	+= smbfs bootfs lx_cgroup lx_devfs
 
@@ -613,7 +599,6 @@
 MISC_KMODS	+= fssnap_if
 MISC_KMODS	+= gda
 MISC_KMODS	+= gld
-MISC_KMODS	+= gsqueue
 MISC_KMODS	+= hidparser
 MISC_KMODS	+= hook
 MISC_KMODS	+= hpcsvc
@@ -730,12 +715,6 @@
 MAC_KMODS	+= mac_ib
 
 #
-#	Overlay related modules (/kernel/overlay)
-#
-DRV_KMODS	+= overlay
-OVERLAY_KMODS	+= vxlan
-
-#
 # socketmod (kernel/socketmod)
 #
 SOCKET_KMODS	+= sockpfp
@@ -743,6 +722,7 @@
 SOCKET_KMODS    += socksdp
 SOCKET_KMODS	+= sockrds
 SOCKET_KMODS	+= ksslf
+SOCKET_KMODS	+= httpfilt
 SOCKET_KMODS	+= datafilt
 
 #
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
